/* Generated By:JavaCC: Do not edit this line. Parser.java */
package fuzzyowl2.parser;

import java.io.*;
import java.util.*;
import fuzzyowl2.*;

/**
 * Parses an OWL 2 annotation into fuzzyDL syntax.
 * @author Fernando Bobillo
 */
public class Parser implements ParserConstants {

  public static double getDegree(String s)
  {
        try
        {
                byte currentXMLBytes[] = s.getBytes();
                ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream(currentXMLBytes);
                Parser parser = new Parser(byteArrayInputStream);
                return parser.Axiom();
        }
        catch (Exception e)
        {
                System.out.println("Error: " + e);
                return 1;
        }
  }


  public static FuzzyLogic getLogic(String s)
  {
        try
        {
                byte currentXMLBytes[] = s.getBytes();
                ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream(currentXMLBytes);
                Parser parser = new Parser(byteArrayInputStream);
                return parser.getFuzzyLogic();
        }
        catch (Exception e)
        {
                System.out.println("Error: " + e);
                return FuzzyLogic.ZADEH;
        }
  }


  public static ConceptDefinition getDefinedConcept(String s)
  {
        try
        {
                byte currentXMLBytes[] = s.getBytes();
                ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream(currentXMLBytes);
                Parser parser = new Parser(byteArrayInputStream);
                return parser.readConcept();
        }
        catch (Exception e)
        {
                System.out.println("Error: " + e);
                return null;
        }
  }


  public static PropertyDefinition getDefinedProperty(String s)
  {
        try
        {
                byte currentXMLBytes[] = s.getBytes();
                ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream(currentXMLBytes);
                Parser parser = new Parser(byteArrayInputStream);
                return parser.readProperty();
        }
        catch (Exception e)
        {
                System.out.println("Error: " + e);
                return null;
        }
  }


  public static Object getDatatype(String s)
  {
        try
        {
                byte currentXMLBytes[] = s.getBytes();
                ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream(currentXMLBytes);
                Parser parser = new Parser(byteArrayInputStream);
                return parser.DatatypeOrModifier();
        }
        catch (Exception e)
        {
                System.out.println("Error: " + e);
                return null;
        }
  }

  final public ConceptDefinition readConcept() throws ParseException {
ConceptDefinition ret;
    CommonBeginning();
    jj_consume_token(CONCEPT);
    getComillas();
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    ret = ConceptConstructor();
    jj_consume_token(EOL);
    CommonEnd();
 {if (true) return ret;}
    throw new Error("Missing return statement in function");
  }

  final public PropertyDefinition readProperty() throws ParseException {
PropertyDefinition ret;
    CommonBeginning();
    jj_consume_token(ROLE);
    getComillas();
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    ret = RoleConstructor();
    jj_consume_token(EOL);
    CommonEnd();
 {if (true) return ret;}
    throw new Error("Missing return statement in function");
  }

  final public void CommonBeginning() throws ParseException {
    jj_consume_token(SIMPLE_COM);
    jj_consume_token(OPEN_TAG);
    jj_consume_token(FUZZYOWL2);
    jj_consume_token(FUZZYTYPE);
    jj_consume_token(EQL);
    getComillas();
  }

  final public void CommonEnd() throws ParseException {
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(FUZZYOWL2);
    jj_consume_token(CLOSE_TAG);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EOL:
      jj_consume_token(EOL);
      break;
    default:
      jj_la1[0] = jj_gen;
      ;
    }
    jj_consume_token(SIMPLE_COM);
  }

  final private ConceptDefinition ConceptConstructor() throws ParseException {
 ConceptDefinition c;
    if (jj_2_1(6)) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(TYPE);
      jj_consume_token(EQL);
      getComillas();
      c = ModifiedConceptStatement();
      jj_consume_token(SLASH);
      jj_consume_token(CLOSE_TAG);
 {if (true) return c;}
    } else if (jj_2_2(6)) {
      c = WeightedConceptStatement();
  {if (true) return c;}
    } else if (jj_2_3(6)) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(TYPE);
      jj_consume_token(EQL);
      getComillas();
      jj_consume_token(WEIGHTED_MAX);
      getComillas();
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      c = WeightedMaxStatement();
  {if (true) return c;}
    } else if (jj_2_4(6)) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(TYPE);
      jj_consume_token(EQL);
      getComillas();
      jj_consume_token(WEIGHTED_MIN);
      getComillas();
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      c = WeightedMinStatement();
  {if (true) return c;}
    } else if (jj_2_5(6)) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(TYPE);
      jj_consume_token(EQL);
      getComillas();
      jj_consume_token(WEIGHTED_SUM);
      getComillas();
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      c = WeightedSumStatement();
  {if (true) return c;}
    } else if (jj_2_6(6)) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(TYPE);
      jj_consume_token(EQL);
      getComillas();
      jj_consume_token(FUZZY_NOMINAL);
      c = FuzzyNominalStatement();
      jj_consume_token(SLASH);
      jj_consume_token(CLOSE_TAG);
  {if (true) return c;}
    } else if (jj_2_7(6)) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(TYPE);
      jj_consume_token(EQL);
      getComillas();
      jj_consume_token(OWA);
      c = OwaStatement();
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(CLOSE_TAG);
  {if (true) return c;}
    } else if (jj_2_8(6)) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(TYPE);
      jj_consume_token(EQL);
      getComillas();
      jj_consume_token(CHOQUET);
      c = ChoquetStatement();
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(CLOSE_TAG);
  {if (true) return c;}
    } else if (jj_2_9(6)) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(TYPE);
      jj_consume_token(EQL);
      getComillas();
      jj_consume_token(SUGENO);
      c = SugenoStatement();
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(CLOSE_TAG);
  {if (true) return c;}
    } else if (jj_2_10(6)) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(TYPE);
      jj_consume_token(EQL);
      getComillas();
      jj_consume_token(QUASI_SUGENO);
      c = QuasiSugenoStatement();
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(CLOSE_TAG);
  {if (true) return c;}
    } else if (jj_2_11(6)) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(TYPE);
      jj_consume_token(EQL);
      getComillas();
      jj_consume_token(QOWA);
      c = qOwaStatement();
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(CONCEPT_DEF);
      jj_consume_token(CLOSE_TAG);
  {if (true) return c;}
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private PropertyDefinition RoleConstructor() throws ParseException {
 PropertyDefinition r;
    jj_consume_token(OPEN_TAG);
    jj_consume_token(ROLE_DEF);
    jj_consume_token(TYPE);
    jj_consume_token(EQL);
    getComillas();
    r = ModifiedRoleStatement();
    jj_consume_token(SLASH);
    jj_consume_token(CLOSE_TAG);
                                                                                                   {if (true) return r;}
    throw new Error("Missing return statement in function");
  }

  final private ConceptDefinition WeightedMaxStatement() throws ParseException {
 ConceptDefinition c, d;
 c = new ConceptDefinition();
 List<ConceptDefinition> list = new ArrayList<ConceptDefinition>();
    label_1:
    while (true) {
      d = WeightedConceptStatement();
                                                  list.add(d);
      jj_consume_token(EOL);
      if (jj_2_12(2)) {
        ;
      } else {
        break label_1;
      }
    }
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(CONCEPT_DEF);
    jj_consume_token(CLOSE_TAG);
 c.weightedMaxConcept(list);
 {if (true) return c;}
    throw new Error("Missing return statement in function");
  }

  final private ConceptDefinition WeightedMinStatement() throws ParseException {
 ConceptDefinition c, d;
 c = new ConceptDefinition();
 List<ConceptDefinition> list = new ArrayList<ConceptDefinition>();
    label_2:
    while (true) {
      d = WeightedConceptStatement();
                                                  list.add(d);
      jj_consume_token(EOL);
      if (jj_2_13(2)) {
        ;
      } else {
        break label_2;
      }
    }
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(CONCEPT_DEF);
    jj_consume_token(CLOSE_TAG);
 c.weightedMinConcept(list);
 {if (true) return c;}
    throw new Error("Missing return statement in function");
  }

  final private ConceptDefinition WeightedSumStatement() throws ParseException {
 ConceptDefinition c, d;
 c = new ConceptDefinition();
 List<ConceptDefinition> list = new ArrayList<ConceptDefinition>();
    label_3:
    while (true) {
      d = WeightedConceptStatement();
                                                  list.add(d);
      jj_consume_token(EOL);
      if (jj_2_14(2)) {
        ;
      } else {
        break label_3;
      }
    }
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(CONCEPT_DEF);
    jj_consume_token(CLOSE_TAG);
 c.weightedSumConcept(list);
 {if (true) return c;}
    throw new Error("Missing return statement in function");
  }

  final private ConceptDefinition OwaStatement() throws ParseException {
 double d;
 Token t;
 ConceptDefinition owa = new ConceptDefinition();
 List<Double> w = new ArrayList<Double>();
 List<String> c = new ArrayList<String>();
    getComillas();
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    jj_consume_token(OPEN_TAG);
    jj_consume_token(WEIGHTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    label_4:
    while (true) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(WEIGHT);
      jj_consume_token(CLOSE_TAG);
      d = Number();
                                                                     w.add(d);
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(WEIGHT);
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      if (jj_2_15(2)) {
        ;
      } else {
        break label_4;
      }
    }
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(WEIGHTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    jj_consume_token(OPEN_TAG);
    jj_consume_token(CONCEPTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    label_5:
    while (true) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(NAME);
      jj_consume_token(CLOSE_TAG);
      t = jj_consume_token(IDENTIFIER);
                                                                       c.add(t.image);
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(NAME);
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      if (jj_2_16(2)) {
        ;
      } else {
        break label_5;
      }
    }
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(CONCEPTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
 owa.owaConcept(w, c);
 {if (true) return owa;}
    throw new Error("Missing return statement in function");
  }

  final private ConceptDefinition ChoquetStatement() throws ParseException {
 double d;
 Token t;
 ConceptDefinition integral = new ConceptDefinition();
 List<Double> w = new ArrayList<Double>();
 List<String> c = new ArrayList<String>();
    getComillas();
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    jj_consume_token(OPEN_TAG);
    jj_consume_token(WEIGHTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    label_6:
    while (true) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(WEIGHT);
      jj_consume_token(CLOSE_TAG);
      d = Number();
                                                                     w.add(d);
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(WEIGHT);
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      if (jj_2_17(2)) {
        ;
      } else {
        break label_6;
      }
    }
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(WEIGHTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    jj_consume_token(OPEN_TAG);
    jj_consume_token(CONCEPTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    label_7:
    while (true) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(NAME);
      jj_consume_token(CLOSE_TAG);
      t = jj_consume_token(IDENTIFIER);
                                                                       c.add(t.image);
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(NAME);
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      if (jj_2_18(2)) {
        ;
      } else {
        break label_7;
      }
    }
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(CONCEPTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
 integral.choquetConcept(w, c);
 {if (true) return integral;}
    throw new Error("Missing return statement in function");
  }

  final private ConceptDefinition qOwaStatement() throws ParseException {
 String q;
 Token t;
 ConceptDefinition qowa = new ConceptDefinition();
 List<String> c = new ArrayList<String>();
    getComillas();
    jj_consume_token(QUANTIFIER);
    jj_consume_token(EQL);
    getComillas();
    t = jj_consume_token(IDENTIFIER);
                                                                  q = t.image;
    getComillas();
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    jj_consume_token(OPEN_TAG);
    jj_consume_token(CONCEPTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    label_8:
    while (true) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(NAME);
      jj_consume_token(CLOSE_TAG);
      t = jj_consume_token(IDENTIFIER);
                                                                       c.add(t.image);
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(NAME);
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      if (jj_2_19(2)) {
        ;
      } else {
        break label_8;
      }
    }
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(CONCEPTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
 qowa.quantifierOwaConcept(q, c);
 {if (true) return qowa;}
    throw new Error("Missing return statement in function");
  }

  final private ConceptDefinition SugenoStatement() throws ParseException {
 double d;
 Token t;
 ConceptDefinition integral = new ConceptDefinition();
 List<Double> w = new ArrayList<Double>();
 List<String> c = new ArrayList<String>();
    getComillas();
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    jj_consume_token(OPEN_TAG);
    jj_consume_token(WEIGHTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    label_9:
    while (true) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(WEIGHT);
      jj_consume_token(CLOSE_TAG);
      d = Number();
                                                                     w.add(d);
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(WEIGHT);
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      if (jj_2_20(2)) {
        ;
      } else {
        break label_9;
      }
    }
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(WEIGHTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    jj_consume_token(OPEN_TAG);
    jj_consume_token(CONCEPTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    label_10:
    while (true) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(NAME);
      jj_consume_token(CLOSE_TAG);
      t = jj_consume_token(IDENTIFIER);
                                                                       c.add(t.image);
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(NAME);
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      if (jj_2_21(2)) {
        ;
      } else {
        break label_10;
      }
    }
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(CONCEPTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
 integral.sugenoConcept(w, c);
 {if (true) return integral;}
    throw new Error("Missing return statement in function");
  }

  final private ConceptDefinition QuasiSugenoStatement() throws ParseException {
 double d;
 Token t;
 ConceptDefinition integral = new ConceptDefinition();
 List<Double> w = new ArrayList<Double>();
 List<String> c = new ArrayList<String>();
    getComillas();
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    jj_consume_token(OPEN_TAG);
    jj_consume_token(WEIGHTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    label_11:
    while (true) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(WEIGHT);
      jj_consume_token(CLOSE_TAG);
      d = Number();
                                                                     w.add(d);
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(WEIGHT);
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      if (jj_2_22(2)) {
        ;
      } else {
        break label_11;
      }
    }
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(WEIGHTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    jj_consume_token(OPEN_TAG);
    jj_consume_token(CONCEPTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    label_12:
    while (true) {
      jj_consume_token(OPEN_TAG);
      jj_consume_token(NAME);
      jj_consume_token(CLOSE_TAG);
      t = jj_consume_token(IDENTIFIER);
                                                                       c.add(t.image);
      jj_consume_token(OPEN_TAG);
      jj_consume_token(SLASH);
      jj_consume_token(NAME);
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      if (jj_2_23(2)) {
        ;
      } else {
        break label_12;
      }
    }
    jj_consume_token(OPEN_TAG);
    jj_consume_token(SLASH);
    jj_consume_token(CONCEPTS);
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
 integral.quasiSugenoConcept(w, c);
 {if (true) return integral;}
    throw new Error("Missing return statement in function");
  }

  final private ConceptDefinition FuzzyNominalStatement() throws ParseException {
  double n;
  Token t;
  ConceptDefinition c = new ConceptDefinition();
    getComillas();
    jj_consume_token(DEGREE_VALUE);
    jj_consume_token(EQL);
    getComillas();
    n = Number();
    getComillas();
    jj_consume_token(INDIVIDUAL);
    jj_consume_token(EQL);
    getComillas();
    t = jj_consume_token(IDENTIFIER);
    getComillas();
  c.fuzzyNominalConcept(n, t.image);
  {if (true) return c;}
    throw new Error("Missing return statement in function");
  }

  final private ConceptDefinition WeightedConceptStatement() throws ParseException {
  ConceptDefinition c = new ConceptDefinition();
    jj_consume_token(OPEN_TAG);
    jj_consume_token(CONCEPT_DEF);
    jj_consume_token(TYPE);
    jj_consume_token(EQL);
    getComillas();
    c = WeightedConcept();
    jj_consume_token(SLASH);
    jj_consume_token(CLOSE_TAG);
 {if (true) return c;}
    throw new Error("Missing return statement in function");
  }

  final private ConceptDefinition WeightedConcept() throws ParseException {
  double n;
  ConceptDefinition c = new ConceptDefinition();
  Token t;
    jj_consume_token(WEIGHTED);
    getComillas();
    jj_consume_token(DEGREE_VALUE);
    jj_consume_token(EQL);
    getComillas();
    n = Number();
    getComillas();
    jj_consume_token(BASE);
    jj_consume_token(EQL);
    getComillas();
    t = jj_consume_token(IDENTIFIER);
    getComillas();
  c.weightedConcept(n, t.image);
  {if (true) return c;}
    throw new Error("Missing return statement in function");
  }

  final private PropertyDefinition ModifiedRoleStatement() throws ParseException {
 Token t1, t2;
 String baseRoleName;
 PropertyDefinition p = new PropertyDefinition();
    jj_consume_token(MODIFIED);
    getComillas();
    jj_consume_token(MODIFIER);
    jj_consume_token(EQL);
    getComillas();
    t1 = jj_consume_token(IDENTIFIER);
    getComillas();
    jj_consume_token(BASE);
    jj_consume_token(EQL);
    getComillas();
    t2 = jj_consume_token(IDENTIFIER);
    getComillas();
 p.modifiedProperty(t1.image, t2.image);
 {if (true) return p;}
    throw new Error("Missing return statement in function");
  }

  final private ConceptDefinition ModifiedConceptStatement() throws ParseException {
 Token t1, t2;
 ConceptDefinition c = new ConceptDefinition();
    jj_consume_token(MODIFIED);
    getComillas();
    jj_consume_token(MODIFIER);
    jj_consume_token(EQL);
    getComillas();
    t1 = jj_consume_token(IDENTIFIER);
    getComillas();
    jj_consume_token(BASE);
    jj_consume_token(EQL);
    getComillas();
    t2 = jj_consume_token(IDENTIFIER);
    getComillas();
  c.modifiedConcept(t1.image, t2.image);
  {if (true) return c;}
    throw new Error("Missing return statement in function");
  }

  final private FuzzyLogic FuzzyLogicStatement() throws ParseException {
 FuzzyLogic fl;
    jj_consume_token(OPEN_TAG);
    jj_consume_token(FUZZY_DEF);
    jj_consume_token(LOGIC);
    jj_consume_token(EQL);
    getComillas();
    fl = Logic();
    getComillas();
    jj_consume_token(SLASH);
    jj_consume_token(CLOSE_TAG);
 {if (true) return fl;}
    throw new Error("Missing return statement in function");
  }

  final private double AxiomStatement() throws ParseException {
 double deg;
    jj_consume_token(OPEN_TAG);
    jj_consume_token(DEGREE_DEF);
    jj_consume_token(DEGREE_VALUE);
    jj_consume_token(EQL);
    getComillas();
    deg = Number();
    getComillas();
    jj_consume_token(SLASH);
    jj_consume_token(CLOSE_TAG);
 {if (true) return deg;}
    throw new Error("Missing return statement in function");
  }

  final public Object DatatypeOrModifier() throws ParseException {
 Object o;
    CommonBeginning();
    o = DatOrMod();
    jj_consume_token(EOL);
    CommonEnd();
 {if (true) return o;}
    throw new Error("Missing return statement in function");
  }

  final private Object DatOrMod() throws ParseException {
 Object o;
    if (jj_2_24(2)) {
      jj_consume_token(DATATYPE);
      getComillas();
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      o = DatatypeStatement();
                                                                    {if (true) return o;}
    } else if (jj_2_25(2)) {
      jj_consume_token(MODIFIER);
      getComillas();
      jj_consume_token(CLOSE_TAG);
      jj_consume_token(EOL);
      o = ModifierStatement();
                                                                    {if (true) return o;}
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private FuzzyModifier ModifierStatement() throws ParseException {
 FuzzyModifier mod;
    jj_consume_token(OPEN_TAG);
    jj_consume_token(MODIFIER_DEF);
    jj_consume_token(TYPE);
    jj_consume_token(EQL);
    getComillas();
    mod = Modifier();
    jj_consume_token(SLASH);
    jj_consume_token(CLOSE_TAG);
                                                                                            {if (true) return mod;}
    throw new Error("Missing return statement in function");
  }

  final private FuzzyModifier Modifier() throws ParseException {
 double a, b, c;
    if (jj_2_26(2)) {
      jj_consume_token(TRI);
      getComillas();
      jj_consume_token(A);
      jj_consume_token(EQL);
      getComillas();
      a = Number();
      getComillas();
      jj_consume_token(B);
      jj_consume_token(EQL);
      getComillas();
      b = Number();
      getComillas();
      jj_consume_token(C);
      jj_consume_token(EQL);
      getComillas();
      c = Number();
      getComillas();
 {if (true) return new TriangularModifier(a, b, c);}
    } else if (jj_2_27(2)) {
      jj_consume_token(LINEAR);
      getComillas();
      jj_consume_token(C);
      jj_consume_token(EQL);
      getComillas();
      c = Number();
      getComillas();
 {if (true) return new LinearModifier(c);}
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private FuzzyDatatype DatatypeStatement() throws ParseException {
 FuzzyDatatype f;
    jj_consume_token(OPEN_TAG);
    jj_consume_token(DATATYPE_DEF);
    jj_consume_token(TYPE);
    jj_consume_token(EQL);
    getComillas();
    f = getFuzzyDatatype();
    jj_consume_token(SLASH);
    jj_consume_token(CLOSE_TAG);
                                                                                                  {if (true) return f;}
    throw new Error("Missing return statement in function");
  }

  final private FuzzyDatatype getFuzzyDatatype() throws ParseException {
 double a, b, c, d;
 Token t1, t2;
    if (jj_2_28(2)) {
      jj_consume_token(LS);
      getComillas();
      jj_consume_token(A);
      jj_consume_token(EQL);
      getComillas();
      a = Number();
      getComillas();
      jj_consume_token(B);
      jj_consume_token(EQL);
      getComillas();
      b = Number();
      getComillas();
 {if (true) return new LeftShoulderFunction(a, b);}
    } else if (jj_2_29(2)) {
      jj_consume_token(RS);
      getComillas();
      jj_consume_token(A);
      jj_consume_token(EQL);
      getComillas();
      a = Number();
      getComillas();
      jj_consume_token(B);
      jj_consume_token(EQL);
      getComillas();
      b = Number();
      getComillas();
 {if (true) return new RightShoulderFunction(a, b);}
    } else if (jj_2_30(2)) {
      jj_consume_token(LINEAR);
      getComillas();
      jj_consume_token(A);
      jj_consume_token(EQL);
      getComillas();
      a = Number();
      getComillas();
      jj_consume_token(B);
      jj_consume_token(EQL);
      getComillas();
      b = Number();
      getComillas();
 {if (true) return new LinearFunction(a, b);}
    } else if (jj_2_31(2)) {
      jj_consume_token(TRI);
      getComillas();
      jj_consume_token(A);
      jj_consume_token(EQL);
      getComillas();
      a = Number();
      getComillas();
      jj_consume_token(B);
      jj_consume_token(EQL);
      getComillas();
      b = Number();
      getComillas();
      jj_consume_token(C);
      jj_consume_token(EQL);
      getComillas();
      c = Number();
      getComillas();
 {if (true) return new TriangularFunction(a, b, c);}
    } else if (jj_2_32(2)) {
      jj_consume_token(TRAP);
      getComillas();
      jj_consume_token(A);
      jj_consume_token(EQL);
      getComillas();
      a = Number();
      getComillas();
      jj_consume_token(B);
      jj_consume_token(EQL);
      getComillas();
      b = Number();
      getComillas();
      jj_consume_token(C);
      jj_consume_token(EQL);
      getComillas();
      c = Number();
      getComillas();
      jj_consume_token(D);
      jj_consume_token(EQL);
      getComillas();
      d = Number();
      getComillas();
 {if (true) return new TrapezoidalFunction(a, b, c, d);}
    } else if (jj_2_33(2)) {
      jj_consume_token(MODIFIED);
      getComillas();
      jj_consume_token(MODIFIER);
      jj_consume_token(EQL);
      getComillas();
      t1 = jj_consume_token(IDENTIFIER);
      getComillas();
      jj_consume_token(BASE);
      jj_consume_token(EQL);
      getComillas();
      t2 = jj_consume_token(IDENTIFIER);
      getComillas();
 {if (true) return new ModifiedFunction(t1.image, t2.image);}
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public double Axiom() throws ParseException {
 double n;
    CommonBeginning();
    jj_consume_token(AXIOM);
    getComillas();
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    n = AxiomStatement();
    jj_consume_token(EOL);
    CommonEnd();
 {if (true) return n;}
    throw new Error("Missing return statement in function");
  }

  final private void getComillas() throws ParseException {
    if (jj_2_34(2)) {
      jj_consume_token(COM1);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SIMPLE_COM:
        jj_consume_token(SIMPLE_COM);
        break;
      default:
        jj_la1[1] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public FuzzyLogic getFuzzyLogic() throws ParseException {
 FuzzyLogic fl;
    CommonBeginning();
    jj_consume_token(ONTOLOGY);
    getComillas();
    jj_consume_token(CLOSE_TAG);
    jj_consume_token(EOL);
    fl = FuzzyLogicStatement();
    jj_consume_token(EOL);
    CommonEnd();
 {if (true) return fl;}
    throw new Error("Missing return statement in function");
  }

  final private FuzzyLogic Logic() throws ParseException {
    if (jj_2_35(2)) {
      jj_consume_token(LUKASIEWICZ);
 {if (true) return FuzzyLogic.LUKASIEWICZ;}
    } else if (jj_2_36(2)) {
      jj_consume_token(ZADEH);
 {if (true) return FuzzyLogic.ZADEH;}
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private double Number() throws ParseException {
   Token n;
    n = jj_consume_token(NUMBER);
   {if (true) return Double.parseDouble(n.image);}
    throw new Error("Missing return statement in function");
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(10, xla); }
  }

  private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_12(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(11, xla); }
  }

  private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_13(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(12, xla); }
  }

  private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_14(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(13, xla); }
  }

  private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_15(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(14, xla); }
  }

  private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_16(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(15, xla); }
  }

  private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_17(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(16, xla); }
  }

  private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_18(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(17, xla); }
  }

  private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_19(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(18, xla); }
  }

  private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_20(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(19, xla); }
  }

  private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_21(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(20, xla); }
  }

  private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_22(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(21, xla); }
  }

  private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_23(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(22, xla); }
  }

  private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_24(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(23, xla); }
  }

  private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_25(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(24, xla); }
  }

  private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_26(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(25, xla); }
  }

  private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_27(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(26, xla); }
  }

  private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_28(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(27, xla); }
  }

  private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_29(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(28, xla); }
  }

  private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_30(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(29, xla); }
  }

  private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_31(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(30, xla); }
  }

  private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_32(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(31, xla); }
  }

  private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_33(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(32, xla); }
  }

  private boolean jj_2_34(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_34(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(33, xla); }
  }

  private boolean jj_2_35(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_35(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(34, xla); }
  }

  private boolean jj_2_36(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_36(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(35, xla); }
  }

  private boolean jj_3_23() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(NAME)) return true;
    return false;
  }

  private boolean jj_3_22() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(WEIGHT)) return true;
    return false;
  }

  private boolean jj_3_33() {
    if (jj_scan_token(MODIFIED)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  private boolean jj_3_8() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(CONCEPT_DEF)) return true;
    if (jj_scan_token(TYPE)) return true;
    if (jj_scan_token(EQL)) return true;
    if (jj_3R_13()) return true;
    if (jj_scan_token(CHOQUET)) return true;
    return false;
  }

  private boolean jj_3_32() {
    if (jj_scan_token(TRAP)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  private boolean jj_3_7() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(CONCEPT_DEF)) return true;
    if (jj_scan_token(TYPE)) return true;
    if (jj_scan_token(EQL)) return true;
    if (jj_3R_13()) return true;
    if (jj_scan_token(OWA)) return true;
    return false;
  }

  private boolean jj_3_31() {
    if (jj_scan_token(TRI)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  private boolean jj_3_6() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(CONCEPT_DEF)) return true;
    if (jj_scan_token(TYPE)) return true;
    if (jj_scan_token(EQL)) return true;
    if (jj_3R_13()) return true;
    if (jj_scan_token(FUZZY_NOMINAL)) return true;
    return false;
  }

  private boolean jj_3_30() {
    if (jj_scan_token(LINEAR)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  private boolean jj_3_29() {
    if (jj_scan_token(RS)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  private boolean jj_3_5() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(CONCEPT_DEF)) return true;
    if (jj_scan_token(TYPE)) return true;
    if (jj_scan_token(EQL)) return true;
    if (jj_3R_13()) return true;
    if (jj_scan_token(WEIGHTED_SUM)) return true;
    return false;
  }

  private boolean jj_3_14() {
    if (jj_3R_15()) return true;
    return false;
  }

  private boolean jj_3_21() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(NAME)) return true;
    return false;
  }

  private boolean jj_3_28() {
    if (jj_scan_token(LS)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  private boolean jj_3_20() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(WEIGHT)) return true;
    return false;
  }

  private boolean jj_3R_14() {
    if (jj_scan_token(MODIFIED)) return true;
    return false;
  }

  private boolean jj_3_4() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(CONCEPT_DEF)) return true;
    if (jj_scan_token(TYPE)) return true;
    if (jj_scan_token(EQL)) return true;
    if (jj_3R_13()) return true;
    if (jj_scan_token(WEIGHTED_MIN)) return true;
    return false;
  }

  private boolean jj_3_3() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(CONCEPT_DEF)) return true;
    if (jj_scan_token(TYPE)) return true;
    if (jj_scan_token(EQL)) return true;
    if (jj_3R_13()) return true;
    if (jj_scan_token(WEIGHTED_MAX)) return true;
    return false;
  }

  private boolean jj_3_13() {
    if (jj_3R_15()) return true;
    return false;
  }

  private boolean jj_3_2() {
    if (jj_3R_15()) return true;
    return false;
  }

  private boolean jj_3_27() {
    if (jj_scan_token(LINEAR)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  private boolean jj_3_1() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(CONCEPT_DEF)) return true;
    if (jj_scan_token(TYPE)) return true;
    if (jj_scan_token(EQL)) return true;
    if (jj_3R_13()) return true;
    if (jj_3R_14()) return true;
    return false;
  }

  private boolean jj_3_19() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(NAME)) return true;
    return false;
  }

  private boolean jj_3_26() {
    if (jj_scan_token(TRI)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  private boolean jj_3_36() {
    if (jj_scan_token(ZADEH)) return true;
    return false;
  }

  private boolean jj_3_12() {
    if (jj_3R_15()) return true;
    return false;
  }

  private boolean jj_3_35() {
    if (jj_scan_token(LUKASIEWICZ)) return true;
    return false;
  }

  private boolean jj_3R_16() {
    if (jj_scan_token(WEIGHTED)) return true;
    return false;
  }

  private boolean jj_3_18() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(NAME)) return true;
    return false;
  }

  private boolean jj_3_25() {
    if (jj_scan_token(MODIFIER)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  private boolean jj_3_17() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(WEIGHT)) return true;
    return false;
  }

  private boolean jj_3_24() {
    if (jj_scan_token(DATATYPE)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  private boolean jj_3R_15() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(CONCEPT_DEF)) return true;
    if (jj_scan_token(TYPE)) return true;
    if (jj_scan_token(EQL)) return true;
    if (jj_3R_13()) return true;
    if (jj_3R_16()) return true;
    return false;
  }

  private boolean jj_3R_13() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_34()) {
    jj_scanpos = xsp;
    if (jj_scan_token(53)) return true;
    }
    return false;
  }

  private boolean jj_3_34() {
    if (jj_scan_token(COM1)) return true;
    return false;
  }

  private boolean jj_3_11() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(CONCEPT_DEF)) return true;
    if (jj_scan_token(TYPE)) return true;
    if (jj_scan_token(EQL)) return true;
    if (jj_3R_13()) return true;
    if (jj_scan_token(QOWA)) return true;
    return false;
  }

  private boolean jj_3_10() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(CONCEPT_DEF)) return true;
    if (jj_scan_token(TYPE)) return true;
    if (jj_scan_token(EQL)) return true;
    if (jj_3R_13()) return true;
    if (jj_scan_token(QUASI_SUGENO)) return true;
    return false;
  }

  private boolean jj_3_16() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(NAME)) return true;
    return false;
  }

  private boolean jj_3_9() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(CONCEPT_DEF)) return true;
    if (jj_scan_token(TYPE)) return true;
    if (jj_scan_token(EQL)) return true;
    if (jj_3R_13()) return true;
    if (jj_scan_token(SUGENO)) return true;
    return false;
  }

  private boolean jj_3_15() {
    if (jj_scan_token(OPEN_TAG)) return true;
    if (jj_scan_token(WEIGHT)) return true;
    return false;
  }

  /** Generated Token Manager. */
  public ParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  private int jj_gen;
  final private int[] jj_la1 = new int[2];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static {
      jj_la1_init_0();
      jj_la1_init_1();
      jj_la1_init_2();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x0,0x0,};
   }
   private static void jj_la1_init_1() {
      jj_la1_1 = new int[] {0x10,0x200000,};
   }
   private static void jj_la1_init_2() {
      jj_la1_2 = new int[] {0x0,0x0,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[36];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  /** Constructor with InputStream. */
  public Parser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public Parser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 2; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 2; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor. */
  public Parser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 2; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 2; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor with generated Token Manager. */
  public Parser(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 2; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 2; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      jj_entries_loop: for (java.util.Iterator<?> it = jj_expentries.iterator(); it.hasNext();) {
        int[] oldentry = (int[])(it.next());
        if (oldentry.length == jj_expentry.length) {
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              continue jj_entries_loop;
            }
          }
          jj_expentries.add(jj_expentry);
          break jj_entries_loop;
        }
      }
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[68];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 2; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 68; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

  private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 36; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
            case 33: jj_3_34(); break;
            case 34: jj_3_35(); break;
            case 35: jj_3_36(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
